import { BaseBatchDeleteManager } from 'src/core/modules/domain/usecase/managers/base-batch-delete.manager';
import { NewsEntity } from '../../entities/news.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { NewsModel } from '../../../data/models/news.model';
import { NewsDeletedEvent } from '../../entities/event/news-deleted.event';
import { BatchResult } from 'src/core/response/domain/ok-response.interface';
import { Injectable } from '@nestjs/common';

@Injectable()
export class BatchDeleteNewsManager extends BaseBatchDeleteManager<NewsEntity> {
  async beforeProcess(): Promise<void> {
    return;
  }

  async validateData(data: NewsEntity): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return NewsModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: NewsDeletedEvent,
      },
    ];
  }

  getResult(): BatchResult {
    return this.result;
  }
}
